
/*
  WolfCrystals - небольшая библиотека, предназначенная для обеспечения 
  поддержки русского языка теми из HD44780-совместимых дисплеев, в память
  знакогенератора которых изначально была зашита катакана, а не кириллица.
  
  -----------------------------------------------------------------------
  Скетч HelloWorldRus:
  
  HelloWorldRus демонстрирует базовые возможности библиотеки -
  вывод русского текста. 
  
  А больше она, собственно, ничего и не умеет :)
  
  -----------------------------------------------------------------------
  Для запуска скетча Вам необходимо собрать схему:
  
          От дисплея:
 * LCD RS pin     - digital pin 12
 * LCD Enable pin - digital pin 11
 * LCD D4 pin     - digital pin 5
 * LCD D5 pin     - digital pin 4
 * LCD D6 pin     - digital pin 3
 * LCD D7 pin     - digital pin 2
 * LCD R/W pin    - ground
    Потенциометр (заменяемый на 10K резистор):
 * концы на +5V и на землю
 * средний контакт на LCD VO pin (pin 3)
  
 Скетч создан 16 апреля 2014
 автор Иван Клёнов (Wolf4D)
 
 Страница библиотеки в Интернет:
 
 */
/////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------
// Обязательно подключаем стандартную библиотеку LiquidCrystal
#include <LiquidCrystal.h>
// Подключаем WolfCrystal
#include <WolfCrystal.h>

//-----------------------------------------------------------------------
// Инициализируем дисплей стандартными средствами
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

// Для работы с библиотекой необходимо создать экземпляр WolfCrystal.
// В конструкторе передаём указатель на ранее созданный 
// экземпляр LiquidCrystal: 
WolfCrystal WC(&lcd); 
// Допускается не передавать указатель в конструктор, но тогда перед 
// первым использованием библиотеки потребуется вызвать метод 
// AddLCD(LiquidCrystal * LCD)

//-----------------------------------------------------------------------
void setup() 
{
  // Инициализируем LCD как обычно
  lcd.begin(16, 2);

  // Для того, чтобы использовать русский, применяем метод GS:
  lcd.print( WC.GS("Привет, мир!") );  
  
  // Метод принимает char* или String, обрабатывает его и отдаёт
  // на выходе также String.
  
  // Это позволяет, не используя промежуточные переменные, легко
  // передавать корректную строку в print самого LiquidCrystal.
  
  // Напишем ещё что-нибудь.
   lcd.setCursor(0, 1);
   lcd.print( WC.GS("Русский-rulez!") );  
}

void loop() {}

// О неполадках и багах в библиотеке пишите на Wolf4D@list.ru

